import Redis from "ioredis";
type ConnectingEvent = {
    type: "CONNECTING";
    attempt: number;
};
type ReconnectingEvent = {
    type: "RECONNECTING";
    attempt: number;
    reconnectingForSecs: number;
};
type FirstReadyEvent = {
    type: "FIRST_READY";
};
type ReconnectedEvent = {
    type: "RECONNECTED";
    wasDisconnectedForSecs: number;
};
type ConnectionEvent = ConnectingEvent | ReconnectingEvent | FirstReadyEvent | ReconnectedEvent;
export declare class ReliableRedisClient {
    private connectionName;
    private redisHost;
    private redisPort;
    private client;
    private isStarting;
    private isStarted;
    private isStopped;
    private connectionAttempt;
    private lastConnectedAt;
    private lastDisconnectAt;
    private disconnectWarning;
    constructor(connectionName: string, redisHost: string, redisPort: number);
    private getNewRedisClient;
    start(eventsCallback?: ((event: ConnectionEvent) => void)): Promise<void>;
    sleep(ms: number): Promise<unknown>;
    getClient(): Redis;
    stop(): void;
}
export {};
