/**
 * A Topic consumer handles the actual reading of and ultimate streaming of a topic
 */
import { TopicMessageDocument, TopicMessageIdentifier } from "./types";
export declare abstract class TopicConsumer<T> {
    topicName: string;
    protected messageCallback: (message: TopicMessageDocument<T>) => Promise<void>;
    protected noMoreMessagesCallback: () => void;
    protected crashCallback: (e: Error) => void;
    protected lastId: TopicMessageIdentifier | null;
    protected queryDoc: any;
    constructor(topicName: string);
    abstract start(): Promise<void>;
    abstract streamMessagesFrom(messageCallback: (message: TopicMessageDocument<T>) => Promise<void>, lastId: null | TopicMessageIdentifier, noMoreMessagesCallback: () => void, crashCallback: () => void): void;
    abstract stop(): Promise<void>;
}
