/**
 * A Topic producer handles the actual writing of messages to a topic
 */
export declare abstract class TopicProducer<T> {
    topicName: string;
    constructor(topicName: string);
    abstract start(): Promise<void>;
    abstract pushMessageToTopic(messagePayload: T, messageShardingKey: string, logCompactId?: string): Promise<void>;
    abstract stop(): Promise<void>;
}
